-- ReputationWindow.lua
-- Written by Habna


function frmReputationWindow()
	frmRP = true;
	faction = nil;
	import (AppClassD.."ComboBox");
	RPDD = HabnaPlugins.TitanBar.Class.ComboBox();

	wReputation = Turbine.UI.Lotro.Window();
	
	wReputation:SetSize( 360, 495 );
    wReputation:SetPosition( RPWLeft, RPWTop );
	wReputation:SetText( L["MReputation"] );
	wReputation:SetVisible( true );
	wReputation:SetWantsKeyEvents( true );
	--wReputation:SetZOrder( 2 );
	wReputation:Activate();

	wReputation.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wReputation:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wReputation:SetVisible( not wReputation:IsVisible() );
		elseif ( args.Action == 162 ) then --Enter key was pressed
			buttonSave.Click( sender, args );
		end
	end

	wReputation.MouseMove = function( sender, args )
		if RPDD.dropped then
			local height = RPDD:GetHeight();
			local x, y = RPDD:GetParent():PointToScreen(RPDD:GetPosition());
			RPDD.dropDownWindow:SetPosition(x, y + height + 2);
		end
	end

	wReputation.MouseUp = function( sender, args )
		settings.Reputation.L = string.format("%.0f", wReputation:GetLeft());
		settings.Reputation.T = string.format("%.0f", wReputation:GetTop());
		RPWLeft, RPWTop = wReputation:GetPosition();
		SaveSettings( false );
	end

	wReputation.Closing = function( sender, args )
		RPDD.dropDownWindow:SetVisible(false);
		wReputation:SetWantsKeyEvents( false );
		wReputation = nil;
		frmRP = nil;
	end
	
	local lbltext = Turbine.UI.Label();
	lbltext:SetParent( wReputation );
	lbltext:SetText( L["RPt"] );
	lbltext:SetPosition( 0, 35);
	lbltext:SetSize( wReputation:GetWidth() , 25 );
	lbltext:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lbltext:SetForeColor( Color["green"] );

	RPListBox = Turbine.UI.ListBox();
	RPListBox:SetParent( wReputation );
	RPListBox:SetZOrder( 1 );
	RPListBox:SetPosition( 20, lbltext:GetTop()+lbltext:GetHeight()+10 );
	RPListBox:SetSize( wReputation:GetWidth()-40, 400 );
	RPListBox:SetMaxItemsPerLine( 1 );
	RPListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--RPListBox:SetBackColor( Color["red"] ); --debug purpose

	RPListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	RPListBoxScrollBar:SetParent( wReputation );
	RPListBoxScrollBar:SetZOrder( 1 );
	RPListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	RPListBox:SetVerticalScrollBar( RPListBoxScrollBar );
	RPListBoxScrollBar:SetPosition( RPListBox:GetWidth()+10, RPListBox:GetTop() );
	RPListBoxScrollBar:SetSize( 10, RPListBox:GetHeight() );

	RPWCtr = Turbine.UI.Control();
	RPWCtr:SetParent( wReputation );
	RPWCtr:SetPosition( RPListBox:GetLeft(), RPListBox:GetTop() );
	RPWCtr:SetSize( RPListBox:GetWidth(), RPListBox:GetHeight() );
	RPWCtr:SetZOrder( 0 );
	RPWCtr:SetVisible( false );
	RPWCtr:SetBlendMode( 5 );
	RPWCtr:SetBackground( 0x4100014c );

	RPWCtr.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			RPWCtr:SetVisible( false );
			RPWCtr:SetZOrder( 0 );
		end
	end

	lblFN = Turbine.UI.Label();
	lblFN:SetParent( RPWCtr );
	lblFN:SetSize( RPWCtr:GetWidth() , 15 );
	lblFN:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblFN:SetFontStyle( Turbine.UI.FontStyle.Outline );
	lblFN:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblFN:SetForeColor( Color["rustedgold"] );

	lblTotal = Turbine.UI.Label();
	lblTotal:SetParent( RPWCtr );
	lblTotal:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblTotal:SetText( L["MIWTotal"] );
	lblTotal:SetSize( lblTotal:GetTextLength() * 9, 15 ); --Auto size with text lenght
	lblTotal:SetForeColor( Color["rustedgold"] );
	lblTotal:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	txtTotal = Turbine.UI.Lotro.TextBox();
	txtTotal:SetParent( RPWCtr );
	txtTotal:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );
	txtTotal:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	txtTotal:SetSize( 80, 20 );
	txtTotal:SetMultiline( false );
	if PlayerAlign == 2 then txtTotal:SetBackColor( Color["red"] ); end

	txtTotal.FocusGained = function( sender, args )
		txtTotal:SelectAll();
		txtTotal:SetWantsUpdates( true );
	end

	txtTotal.FocusLost = function( sender, args )
		txtTotal:SetWantsUpdates( false );
	end

	txtTotal.Update = function( sender, args )
		local parsed_text = txtTotal:GetText();
		if tonumber(parsed_text) == nil or string.find(parsed_text,"%.") ~= nil then
			txtTotal:SetText( string.sub( parsed_text, 1, string.len(parsed_text)-1 ) );
			--txtTotal:Focus();
			return
		elseif string.len(parsed_text) > 1 and string.sub(parsed_text,1,1) == "0" then
			txtTotal:SetText( string.sub( parsed_text, 2 ) );
			return
		end
	end

	newt = {};
	for i = 1, maxrank do -- Number of rank in drop down box
		if i <= 5 then table.insert(newt, L["RPGL"..i]);
		elseif i <= 10 then table.insert(newt, L["RPBL"..i-5]);
		elseif i <= maxrank then table.insert(newt, L["RPGG"..i-10]); end
	end

	buttonSave = Turbine.UI.Lotro.Button();
	buttonSave:SetParent( RPWCtr );
	buttonSave:SetText( L["PWSave"] );
	buttonSave:SetSize( buttonSave:GetTextLength() * 10, 15 ); --Auto size with text lenght
	--buttonSave:SetEnabled( true );

	buttonSave.Click = function( sender, args )
		if txtTotal:GetText() == "" then
			txtTotal:SetText( "0" );
			txtTotal:Focus();
			return
		end

		txtTotal:Focus();
		RPWCtr:SetVisible( false );
		RPWCtr:SetZOrder( 0 );

		factionIndex=nil;
		for j = 1, maxfaction+maxgfaction do
			if PlayerReputation[PN][tostring(j)][TBLocale] == faction then factionIndex = j; break end
		end

		for i = 1, maxrank do --number of rank in the drop down box
			if newt[i] == RPDD.label:GetText() then
				if i <= 5 then
					PlayerReputation[PN][tostring(factionIndex)].S = "good";
					PlayerReputation[PN][tostring(factionIndex)].R = tostring(i);
				elseif i <= 10 then
					PlayerReputation[PN][tostring(factionIndex)].S = "bad";
					PlayerReputation[PN][tostring(factionIndex)].R = tostring(i-5);
				elseif i <= maxrank then
					PlayerReputation[PN][tostring(factionIndex)].S = "guild";
					PlayerReputation[PN][tostring(factionIndex)].R = tostring(i-10);
				end
				break
			end
		end

		PlayerReputation[PN][tostring(factionIndex)].P = txtTotal:GetText();
		SavePlayerReputation();
	end

	lblRank = Turbine.UI.Label();
	lblRank:SetParent( RPWCtr );
	lblRank:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblRank:SetText( L["IFCR"] );
	lblRank:SetSize( lblRank:GetTextLength() * 9, 15 ); --Auto size with text lenght
	lblRank:SetForeColor( Color["rustedgold"] );
	lblRank:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	RefreshRPListBox();
end

function RefreshRPListBox()
	RPListBox:ClearItems();
	RPPosY = 0;
	
	for i = 1, #FactionOrder do
		RPPosY = RPPosY + 20;
		
		--**v Control of all data v**
		local RPCtr = Turbine.UI.Control();
		RPCtr:SetParent( RPListBox );
		RPCtr:SetSize( RPListBox:GetWidth(), 20 );
		--**^
	
		-- Reputation name
		local repLbl = Turbine.UI.Lotro.CheckBox();
		repLbl:SetParent( RPCtr );
		repLbl:SetText( PlayerReputation[PN][tostring(FactionOrder[i])][TBLocale] );
		repLbl:SetSize( RPListBox:GetWidth()-10, 20 );
		repLbl:SetPosition( 0, 0 );
		repLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		repLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		repLbl:SetForeColor( Color["nicegold"] );
		repLbl:SetChecked( PlayerReputation[PN][tostring(FactionOrder[i])].V );
		--repLbl:SetBackColor( Color["blue"] ); --debug purpose

		repLbl.MouseClick = function( sender, args )
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				faction = PlayerReputation[PN][tostring(FactionOrder[i])][TBLocale];
				lblFN:SetText( faction );
				txtTotal:SetText( PlayerReputation[PN][tostring(FactionOrder[i])].P );

				local tr = nil;
				local ts = PlayerReputation[PN][tostring(FactionOrder[i])].S;
				local tra = tonumber(PlayerReputation[PN][tostring(FactionOrder[i])].R);
				if ts == "good" then tr = RPGL[tra];
				elseif ts == "bad" then tr = RPBL[tra];
				elseif ts == "guild" then tr = RPGGL[tra]; end

				-- Rank in drop down box
				--RPDD = HabnaPlugins.TitanBar.Class.ComboBox();
				RPDD:SetParent( RPWCtr );
				RPDD:SetSize( 159, 19 );
				RPDD:SetPosition( lblRank:GetLeft()+lblRank:GetWidth()+5, lblTotal:GetTop()+lblTotal:GetHeight()+10 );
				--RPDD:SetVisible( true );

				for k,v in pairs(newt) do
					RPDD:AddItem(v, k);
					if v == tr then RPDD:SetSelection(k); end
				end

				RPDD.ItemChanged = function( sender, args ) -- The event that's executed when a menu item is clicked.
					
				end

				RPWCtr:SetVisible( true );
				RPWCtr:SetZOrder( 2 );
				txtTotal:Focus();
			end
		end

		repLbl.CheckedChanged = function( sender, args )
			PlayerReputation[PN][tostring(FactionOrder[i])].V = repLbl:IsChecked();
			SavePlayerReputation();
		end

		RPListBox:AddItem( RPCtr );
	end

	--RPListBox:SetHeight( RPPosY );
	--RPWCtr:SetHeight( RPPosY );

	lblFN:SetPosition( 0 , RPWCtr:GetHeight()/2 - 40 );
	lblTotal:SetPosition( 30 , RPWCtr:GetHeight()/2 - 15 );
	txtTotal:SetPosition( lblTotal:GetLeft()+lblTotal:GetWidth()+5, lblTotal:GetTop()-2 );
	buttonSave:SetPosition( txtTotal:GetLeft()+txtTotal:GetWidth()+5, txtTotal:GetTop() );
	lblRank:SetPosition( lblTotal:GetLeft(), lblTotal:GetTop()+lblTotal:GetHeight()+10 );

	--wReputation:SetHeight( RPPosY + 95 );
end